#include<stdio.h>
#include<assert.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include<unistd.h>
#include<gtk/gtk.h>

#include "FileSelector.h"

#include "opledit.h"

#include "pixmaps/algo1.xpm"
#include "pixmaps/algo2.xpm"
#include "pixmaps/algo3.xpm"
#include "pixmaps/algo4.xpm"
#include "pixmaps/algo5.xpm"
#include "pixmaps/algo6.xpm"



class gtkWidget {
	protected:
		GtkWidget *widget;
	public:
		GtkWidget *getWidget() {return widget;}
		int signal_connect(char *ev,GtkSignalFunc func,void *data);
		void show();
		void set_sensitive(bool v);
};

int gtkWidget::signal_connect(char *ev,GtkSignalFunc func,void *data) {
	return 
		gtk_signal_connect(GTK_OBJECT(widget),ev,GTK_SIGNAL_FUNC(func),data);
}

void gtkWidget::show() {
	gtk_widget_show(widget);
}

void gtkWidget::set_sensitive(bool v) {
	gtk_widget_set_sensitive(widget,v);
}

class Operator : public gtkWidget {
	GtkWidget *Harmonic;
	GtkWidget *Volume;
	GtkWidget *Attack;
	GtkWidget *Sustain;
	GtkWidget *Decay;
	GtkWidget *Release;
	GtkWidget *Tremolo;
	GtkWidget *Vibrato;
	GtkWidget *SustainToggle;
	GtkWidget *Scaling;
	GtkWidget *ScaleFactor_menu;
	GtkWidget *Waveform_menu;
	GtkWidget *ScaleFactor;
	GtkWidget *Waveform;

	
	public:
		Operator(int num);
		void randomize();
		unsigned char getByte(int i);
		void setByte(int i,unsigned char c);
};

void Operator::randomize() {
	
	setByte(0,(rand()&0xFF));
	setByte(1,(rand()&0xFF));
	setByte(2,(rand()&0xFF));
	setByte(3,(rand()&0xFF));
	setByte(4,(rand()&0xFF));
	//TODO write smart random routines.
}

unsigned char Operator::getByte(int i) {
	unsigned char c = 0;
	switch(i) {
		case 0:
			c|=(((int)(gtk_range_get_adjustment(GTK_RANGE(Harmonic))->value))&0xF);
			c|=GTK_TOGGLE_BUTTON(Scaling)->active<<4;
			c|=GTK_TOGGLE_BUTTON(SustainToggle)->active<< 5;
			c|=GTK_TOGGLE_BUTTON(Vibrato)->active<<6;
			c|=GTK_TOGGLE_BUTTON(Tremolo)->active<<7;
			return c;
		case 1: 
			c|= (((int)gtk_range_get_adjustment(GTK_RANGE(Volume))->value)); 
			c|= (((int)gtk_object_get_data(GTK_OBJECT(gtk_menu_get_active(GTK_MENU(ScaleFactor_menu))),"Which"))<<6);
			return c;

		case 2:
		 c|=((int)(gtk_range_get_adjustment(GTK_RANGE(Attack))->value))<<4; 
		c|=(int)gtk_range_get_adjustment(GTK_RANGE(Decay))->value;
			return c;
		case 3:
		 c|=((int)(gtk_range_get_adjustment(GTK_RANGE(Sustain))->value))<<4; 
		c|=(int)gtk_range_get_adjustment(GTK_RANGE(Release))->value;
			return c;
		case 4:
			
			//gtk_option_menu_set_history(GTK_OPTION_MENU(Waveform),c);
			c = (int)gtk_object_get_data(
			GTK_OBJECT(gtk_menu_get_active(GTK_MENU(Waveform_menu))),
			"Which");
			return c;
			break;
		default:
			assert(!"getByte: Index out of range.");
			return 0;

	}


	return 0;
}

void Operator::setByte(int i,unsigned char c) {
	switch(i) {
		case 0:
			gtk_adjustment_set_value(
				gtk_range_get_adjustment(GTK_RANGE(Harmonic)),(c&0xF)); 
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(Scaling),(c>>4)&1);
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(SustainToggle),(c>>5)&1);
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(Vibrato),(c>>6)&1);
			gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(Tremolo),(c>>7)&1);
			break;
		case 1: 
			gtk_adjustment_set_value(gtk_range_get_adjustment(GTK_RANGE(Volume)),(c&0x3F)); 
			gtk_menu_set_active(GTK_MENU(ScaleFactor_menu),c>>6);
			gtk_option_menu_set_history(GTK_OPTION_MENU(ScaleFactor),c>>6);
			break;

		case 2:
			gtk_adjustment_set_value(
				 gtk_range_get_adjustment(GTK_RANGE(Attack)),(c>>4)&0xF); 
			gtk_adjustment_set_value(
				gtk_range_get_adjustment(GTK_RANGE(Decay)),c&0xF);
		   	break;
		case 3:
			gtk_adjustment_set_value(
				 gtk_range_get_adjustment(GTK_RANGE(Sustain)),(c>>4)&0xF); 
			gtk_adjustment_set_value(
				gtk_range_get_adjustment(GTK_RANGE(Release)),c&0xF);
		   	break;
		case 4:
			gtk_menu_set_active(GTK_MENU(Waveform_menu),c&0x7);
			gtk_option_menu_set_history(GTK_OPTION_MENU(Waveform),c&0x7);
			break;
		default:
			assert(!"setByte: Index out of range.");
	
	}

}



Operator::Operator(int num) {
	char buf[60];
	sprintf(buf,"Operator %i",num);
	GtkWidget *TopFrame = gtk_frame_new (buf);
	gtk_widget_show (TopFrame);
	//  gtk_container_add (GTK_CONTAINER (window1), TopFrame);
	gtk_container_border_width (GTK_CONTAINER (TopFrame), 3);

	GtkWidget *vbox70 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox70);
	gtk_container_add (GTK_CONTAINER (TopFrame), vbox70);

	GtkWidget *hbox44 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox44);
	gtk_box_pack_start (GTK_BOX (vbox70), hbox44, TRUE, TRUE, 0);

	Tremolo = gtk_check_button_new_with_label ("Tremolo");
	gtk_widget_show (Tremolo);
	gtk_box_pack_start (GTK_BOX (hbox44), Tremolo, TRUE, TRUE, 0);

	Vibrato = gtk_check_button_new_with_label ("Vibrato");
	gtk_widget_show (Vibrato);
	gtk_box_pack_start (GTK_BOX (hbox44), Vibrato, TRUE, TRUE, 0);

	SustainToggle = gtk_check_button_new_with_label ("Sustain");
	gtk_widget_show (SustainToggle);
	gtk_box_pack_start (GTK_BOX (hbox44), SustainToggle, TRUE, TRUE, 0);

	Scaling = gtk_check_button_new_with_label ("Scaling");
	gtk_widget_show (Scaling);
	gtk_box_pack_start (GTK_BOX (hbox44), Scaling, TRUE, TRUE, 0);

	GtkWidget *hbox45 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox45);
	gtk_box_pack_start (GTK_BOX (vbox70), hbox45, TRUE, TRUE, 0);

	GtkWidget *frame21 = gtk_frame_new ("Envelope");
	gtk_widget_show (frame21);
	gtk_box_pack_start (GTK_BOX (hbox45), frame21, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (frame21), 3);

	GtkWidget *vbox75 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox75);
	gtk_container_add (GTK_CONTAINER (frame21), vbox75);

	GtkWidget *hbox46 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox46);
	gtk_box_pack_start (GTK_BOX (vbox75), hbox46, TRUE, TRUE, 0);

	GtkWidget *label102 = gtk_label_new ("A");
	gtk_widget_show (label102);
	gtk_box_pack_start (GTK_BOX (hbox46), label102, FALSE, TRUE, 0);

	Attack = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 15, 1, 0, 0)));
	gtk_widget_show (Attack);
	gtk_box_pack_start (GTK_BOX (hbox46), Attack, TRUE, TRUE, 0);
	gtk_scale_set_draw_value (GTK_SCALE (Attack), FALSE);

	GtkWidget *hbox48 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox48);
	gtk_box_pack_start (GTK_BOX (vbox75), hbox48, TRUE, TRUE, 0);

	GtkWidget *label104 = gtk_label_new ("D");
	gtk_widget_show (label104);
	gtk_box_pack_start (GTK_BOX (hbox48), label104, FALSE, TRUE, 0);

	Decay = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 15, 1, 0, 0)));
	gtk_widget_show (Decay);
	gtk_box_pack_start (GTK_BOX (hbox48), Decay, TRUE, TRUE, 0);
	gtk_scale_set_draw_value (GTK_SCALE (Decay), FALSE);

	GtkWidget *hbox47 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox47);
	gtk_box_pack_start (GTK_BOX (vbox75), hbox47, TRUE, TRUE, 0);

	GtkWidget *label103 = gtk_label_new ("S");
	gtk_widget_show (label103);
	gtk_box_pack_start (GTK_BOX (hbox47), label103, FALSE, TRUE, 0);

	Sustain = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 15, 1, 0, 0)));
	gtk_widget_show (Sustain);
	gtk_box_pack_start (GTK_BOX (hbox47), Sustain, TRUE, TRUE, 0);
	gtk_scale_set_draw_value (GTK_SCALE (Sustain), FALSE);

	GtkWidget *hbox49 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox49);
	gtk_box_pack_start (GTK_BOX (vbox75), hbox49, TRUE, TRUE, 0);

	GtkWidget *label105 = gtk_label_new ("R");
	gtk_widget_show (label105);
	gtk_box_pack_start (GTK_BOX (hbox49), label105, FALSE, TRUE, 0);

	Release = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 15, 1, 0, 0)));
	gtk_widget_show (Release);
	gtk_box_pack_start (GTK_BOX (hbox49), Release, TRUE, TRUE, 0);
	gtk_scale_set_draw_value (GTK_SCALE (Release), FALSE);

	GtkWidget *vbox72 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox72);
	gtk_box_pack_start (GTK_BOX (hbox45), vbox72, TRUE, TRUE, 0);

	ScaleFactor = gtk_option_menu_new ();
	gtk_widget_show (ScaleFactor);
	gtk_box_pack_start (GTK_BOX (vbox72), ScaleFactor, FALSE, TRUE, 0);
	ScaleFactor_menu = gtk_menu_new ();
	GtkWidget *glade_menuitem = gtk_menu_item_new_with_label ("no change");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)0);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (ScaleFactor_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("1.5 dB/8ve");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)1);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (ScaleFactor_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("3 dB/8ve");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)2);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (ScaleFactor_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("6 dB/8ve");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)3);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (ScaleFactor_menu), glade_menuitem);
	gtk_option_menu_set_menu (GTK_OPTION_MENU (ScaleFactor), ScaleFactor_menu);

	Waveform = gtk_option_menu_new ();
	gtk_widget_show (Waveform);
	gtk_box_pack_start (GTK_BOX (vbox72), Waveform, FALSE, TRUE, 0);
	Waveform_menu = gtk_menu_new ();
	glade_menuitem = gtk_menu_item_new_with_label ("Sine");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)0);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("Half-Sine");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)1);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("Abs-Sine");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)2);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("Pulse");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)3);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("Even-Sine");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)4);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("AbsEvenSine");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)5);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("Square");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)6);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	glade_menuitem = gtk_menu_item_new_with_label ("DSquareDt");
	gtk_object_set_data(GTK_OBJECT(glade_menuitem),"Which",(gpointer)7);
	gtk_widget_show (glade_menuitem);
	gtk_menu_append (GTK_MENU (Waveform_menu), glade_menuitem);
	gtk_option_menu_set_menu (GTK_OPTION_MENU (Waveform), Waveform_menu);

	GtkWidget *vbox73 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox73);
	gtk_box_pack_start (GTK_BOX (vbox72), vbox73, TRUE, TRUE, 0);

	GtkWidget *frame22 = gtk_frame_new ("Harmonic");
	gtk_widget_show (frame22);
	gtk_box_pack_start (GTK_BOX (vbox73), frame22, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (frame22), 3);

	Harmonic = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 15, 1, 0, 0)));
	gtk_widget_show (Harmonic);
	gtk_container_add (GTK_CONTAINER (frame22), Harmonic);
	gtk_scale_set_value_pos (GTK_SCALE (Harmonic), GTK_POS_LEFT);
	gtk_scale_set_digits (GTK_SCALE (Harmonic), 0);

	GtkWidget *frame23 = gtk_frame_new ("Volume");
	gtk_widget_show (frame23);
	gtk_box_pack_start (GTK_BOX (hbox45), frame23, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (frame23), 3);

	Volume = gtk_vscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 63, 1, 0, 0)));
	gtk_widget_show (Volume);
	gtk_container_add (GTK_CONTAINER (frame23), Volume);
	gtk_scale_set_draw_value (GTK_SCALE (Volume), FALSE);
	gtk_scale_set_digits (GTK_SCALE (Volume), 0);

	widget = TopFrame;
}


FileSelector OpenFileSelector("Open File..."),SaveFileSelector("Save as...");




void
on_Open_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	OpenFileSelector.raise();

}


void
on_Save_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
	SaveFileSelector.raise();
}

gboolean
on_MainWindow_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_exit(0);

  return FALSE;
}



class PixmapSpinner : public gtkWidget {
	GdkPixmap *pm[6];
	GdkBitmap *mask[6];
	public:
	PixmapSpinner(GtkWidget *mainwin);
	void set(int i);
};



PixmapSpinner::PixmapSpinner(GtkWidget *realizedwin) {
	pm[0] = gdk_pixmap_create_from_xpm_d(realizedwin->window,&mask[0],&realizedwin->style->bg[GTK_STATE_NORMAL],(gchar**)algo1);
	pm[1] = gdk_pixmap_create_from_xpm_d(realizedwin->window,&mask[1],&realizedwin->style->bg[GTK_STATE_NORMAL],(gchar**)algo2);
	pm[2] = gdk_pixmap_create_from_xpm_d(realizedwin->window,&mask[2],&realizedwin->style->bg[GTK_STATE_NORMAL],(gchar**)algo3);
	pm[3] = gdk_pixmap_create_from_xpm_d(realizedwin->window,&mask[3],&realizedwin->style->bg[GTK_STATE_NORMAL],(gchar**)algo4);
	pm[4] = gdk_pixmap_create_from_xpm_d(realizedwin->window,&mask[4],&realizedwin->style->bg[GTK_STATE_NORMAL],(gchar**)algo5);
	pm[5] = gdk_pixmap_create_from_xpm_d(realizedwin->window,&mask[5],&realizedwin->style->bg[GTK_STATE_NORMAL],(gchar**)algo6);
	widget = gtk_pixmap_new(pm[0],mask[0]);
}

void PixmapSpinner::set(int i) {
	assert(i>=0 && i<6);
	gtk_pixmap_set(GTK_PIXMAP(widget),pm[i],mask[i]);
}



class MainWindow : public gtkWidget {
	Operator op1;
	Operator op2;
	Operator op3;
	Operator op4;
	GtkWidget *Algorithm;
	GtkWidget *AlgorithmPixmap;
	GtkWidget *Feedback;
	GtkWidget *Name;
	PixmapSpinner *pspin;
	static void on_Algorithm_Changed(GtkAdjustment *,gpointer);
	public:
	MainWindow();
	bool SaveToFile(char *file);
	bool LoadFromFile(char *file);
	void SaveDataToBuffer(char *buf);
	void dumpDataToFm();
	void randomize();
};

void MainWindow::randomize() {
	gtk_adjustment_set_value(gtk_range_get_adjustment(GTK_RANGE(Feedback)),rand()%8);
	gtk_adjustment_set_value(gtk_range_get_adjustment(GTK_RANGE(Algorithm)),rand()%6);
	op1.randomize();
	op2.randomize();
	if(gtk_range_get_adjustment(GTK_RANGE(Algorithm))->value<4) {
		op3.randomize();
		op4.randomize();
	}
}


void
on_Quit_clicked (GtkButton *button, gpointer user_data) {
	gtk_exit(0);
}

void
on_Random_clicked (GtkButton *button, gpointer user_data) {
	((MainWindow *)user_data)->randomize();
}


void
on_OpenOkButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	char *fn = OpenFileSelector.get_filename();
	if(((MainWindow *)user_data)->LoadFromFile(fn))
		OpenFileSelector.hide();
}



void
on_SaveOkButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	char *fn = SaveFileSelector.get_filename();
	if(((MainWindow *)user_data)->SaveToFile(fn))
		SaveFileSelector.hide();

}


void MainWindow::dumpDataToFm() {
	char buf[60];
	SaveDataToBuffer(buf);
	void load_fm(char *buf,bool );
	load_fm(buf,gtk_range_get_adjustment(GTK_RANGE(Algorithm))->value<4);
}


void MainWindow::on_Algorithm_Changed(GtkAdjustment *adj,gpointer data) {
	((MainWindow *)data)->pspin->set(adj->value);
	if(((int)adj->value)>3) {
		((MainWindow *)data)->op3.set_sensitive(false);
		((MainWindow *)data)->op4.set_sensitive(false);
	} else {
		((MainWindow *)data)->op3.set_sensitive(true);
		((MainWindow *)data)->op4.set_sensitive(true);
	}
}


MainWindow::MainWindow() : op1(1),op2(2),op3(3),op4(4) {
	GtkWidget *vbox8;
	GtkWidget *hbox41;
	GtkWidget *hbuttonbox2;
	GtkWidget *Quit;
	GtkWidget *Random;
	GtkWidget *Open;
	GtkWidget *Save;
	GtkWidget *vbox71;
	GtkWidget *frame20;
	GtkWidget *frame21;
	GtkWidget *frame18;
	GtkWidget *hbox43;
	GtkWidget *vbox70;
	GtkWidget *table4;

	widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
						GTK_SIGNAL_FUNC (on_MainWindow_delete_event),
						NULL);
	gtk_window_set_title (GTK_WINDOW (widget), "OPL3 Patch Editor");
	gtk_window_set_policy (GTK_WINDOW (widget), FALSE, FALSE, FALSE);
	gtk_widget_realize(widget);

	vbox8 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox8);
	gtk_container_add (GTK_CONTAINER (widget), vbox8);

	hbox41 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox41);
	gtk_box_pack_start (GTK_BOX (vbox8), hbox41, TRUE, TRUE, 0);

	hbuttonbox2 = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox2);
	gtk_box_pack_start (GTK_BOX (hbox41), hbuttonbox2, FALSE, TRUE, 0);

	Quit = gtk_button_new_with_label ("Quit");
	gtk_widget_show (Quit);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), Quit);
	gtk_signal_connect (GTK_OBJECT (Quit), "clicked",
						GTK_SIGNAL_FUNC (on_Quit_clicked),
						this);

	Random = gtk_button_new_with_label ("Randomize");
	gtk_widget_show (Random);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), Random);
	gtk_signal_connect (GTK_OBJECT (Random), "clicked",
						GTK_SIGNAL_FUNC (on_Random_clicked),
						this);

	Open = gtk_button_new_with_label ("Open");
	gtk_widget_show (Open);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), Open);
	gtk_signal_connect (GTK_OBJECT (Open), "clicked",
						GTK_SIGNAL_FUNC (on_Open_clicked),
						NULL);

	Save = gtk_button_new_with_label ("Save");
	gtk_widget_show (Save);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), Save);
	gtk_signal_connect (GTK_OBJECT (Save), "clicked",
						GTK_SIGNAL_FUNC (on_Save_clicked),
						NULL);

	vbox71 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox71);
	gtk_box_pack_start (GTK_BOX (hbox41), vbox71, TRUE, TRUE, 0);

	frame20 = gtk_frame_new ("Name");
	gtk_widget_show (frame20);
	gtk_box_pack_start (GTK_BOX (vbox71), frame20, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (frame20), 3);

	Name = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(Name),31);
	gtk_widget_show (Name);
	gtk_container_add (GTK_CONTAINER (frame20), Name);

	frame21 = gtk_frame_new ("Feedback");
	gtk_widget_show (frame21);
	gtk_box_pack_start (GTK_BOX (vbox71), frame21, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (frame21), 3);

	Feedback = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 7, 1, 0, 0)));
	gtk_widget_show (Feedback);
	gtk_container_add (GTK_CONTAINER (frame21), Feedback);
	gtk_scale_set_value_pos (GTK_SCALE (Feedback), GTK_POS_LEFT);
	gtk_scale_set_digits (GTK_SCALE (Feedback), 0);

	frame18 = gtk_frame_new ("Algorithm");
	gtk_widget_show (frame18);
	gtk_box_pack_start (GTK_BOX (hbox41), frame18, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (frame18), 3);

	hbox43 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox43);
	gtk_container_add (GTK_CONTAINER (frame18), hbox43);

	vbox70 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox70);
	gtk_box_pack_start (GTK_BOX (hbox43), vbox70, TRUE, TRUE, 0);

	pspin = new PixmapSpinner(widget);
	pspin->show();
	gtk_box_pack_start (GTK_BOX (vbox70), pspin->getWidget(), TRUE, TRUE, 0);

	Algorithm = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 5, 1, 0, 0)));
	gtk_widget_show (Algorithm);
	gtk_box_pack_start (GTK_BOX (vbox70), Algorithm, TRUE, TRUE, 0);
	gtk_scale_set_draw_value (GTK_SCALE (Algorithm), FALSE);
	gtk_scale_set_digits (GTK_SCALE (Algorithm), 0);

	gtk_signal_connect(GTK_OBJECT(gtk_range_get_adjustment(GTK_RANGE(Algorithm))),"value-changed",GTK_SIGNAL_FUNC(on_Algorithm_Changed),this);

	table4 = gtk_table_new (2, 2, FALSE);
	gtk_widget_show (table4);
	gtk_box_pack_start (GTK_BOX (vbox8), table4, FALSE, TRUE, 0);

	gtk_table_attach (GTK_TABLE (table4), op1.getWidget(), 0, 1, 0, 1,
					  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

	gtk_table_attach (GTK_TABLE (table4), op3.getWidget(), 0, 1, 1, 2,
					  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

	gtk_table_attach (GTK_TABLE (table4), op2.getWidget(), 1, 2, 0, 1,
					  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions)( GTK_EXPAND | GTK_FILL), 0, 0);

	gtk_table_attach (GTK_TABLE (table4), op4.getWidget(), 1, 2, 1, 2,
					  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
	
	OpenFileSelector.signal_connect(GTK_SIGNAL_FUNC(on_OpenOkButton_clicked),this);
	SaveFileSelector.signal_connect(GTK_SIGNAL_FUNC(on_SaveOkButton_clicked),this);
	
}



void MainWindow::SaveDataToBuffer(char *buf) {
	int algorithm = (int)gtk_range_get_adjustment(GTK_RANGE(Algorithm))->value;
	int count = 0;
	for(int i = 0;i<5;i++) {
		buf[count++] = op1.getByte(i);
		buf[count++] = op2.getByte(i);
	}
	int feedback = (int)gtk_range_get_adjustment(GTK_RANGE(Feedback))->value;
	feedback <<=1;
	if(algorithm>3) {
		feedback |= (algorithm&1);
		buf[count++] = (unsigned char)feedback;
		return;
	}
	feedback |= ((algorithm>>1)&1);
	buf[count++] = (unsigned char)feedback;

	for(int i = 0;i<5;i++) {
		buf[count++] = op3.getByte(i);
		buf[count++] = op4.getByte(i);
	}
	feedback &= 0xFE;
	feedback |= (algorithm&1);
	buf[count++] = (unsigned  char)feedback;
	while (count < (60-36))
		buf[count++] = 0;
}

bool MainWindow::SaveToFile(char *file) {
	FILE *f = fopen(file,"w");
	if(!f) return false;

	if(gtk_range_get_adjustment(GTK_RANGE(Algorithm))->value>3) 
		fwrite("2OP\032",4,1,f);
	else 
		fwrite("4OP\032",4,1,f);
	char *name = gtk_entry_get_text(GTK_ENTRY(Name));
	fwrite(name,31,1,f);
	fputc(0,f);
	char buf[60];
	SaveDataToBuffer(buf);
	fwrite(buf,60-36,1,f);
	fclose(f);
	return true;
}

bool MainWindow::LoadFromFile(char *file) {
	int operators = -1;
	FILE *f = fopen(file,"r");
	if(!f)
		return false;
	char buf[32];
	fread(buf,4,1,f);
	if(!strncmp(buf,"4OP",3)) {
		operators = 4;
	}
	if(!strncmp(buf,"SBI",3) || !strncmp(buf,"2OP",3)) {
		operators = 2;
	}
	if(operators<0) {
		fprintf(stderr,"File not in SBI format.\n");
		fclose(f);
		return false;
	}
	if(operators== 2) {
		op3.set_sensitive(false);
		op4.set_sensitive(false);
	} else {
		op3.set_sensitive(true);
		op4.set_sensitive(true);
	}
	fread(buf,32,1,f);
	gtk_entry_set_text(GTK_ENTRY(Name),buf);
	for(int i=0;i<5;i++){
		unsigned char c;
		fread(&c,1,1,f);
		op1.setByte(i,c);
		fread(&c,1,1,f);
		op2.setByte(i,c);
	}
	unsigned char c;
	fread(&c,1,1,f);
	gtk_adjustment_set_value( gtk_range_get_adjustment(GTK_RANGE(Feedback)),(c>>1)&0x7); 
	if(operators == 2) {
		if (c&1) 
			gtk_adjustment_set_value( gtk_range_get_adjustment(GTK_RANGE(Algorithm)),5); 
		else
			gtk_adjustment_set_value( gtk_range_get_adjustment(GTK_RANGE(Algorithm)),4); 
		fclose(f);
		return true;
	}
	unsigned char connection=(c&1)<<1;
	for(int i=0;i<5;i++){
		unsigned char c;
		fread(&c,1,1,f);
		op3.setByte(i,c);
		fread(&c,1,1,f);
		op4.setByte(i,c);
	}
	fread(&c,1,1,f);
	connection |= (c&1);
	gtk_adjustment_set_value( gtk_range_get_adjustment(GTK_RANGE(Algorithm)),connection); 
	fclose(f);
	return true;
}

gboolean midi_idle(gpointer data);
void init_seq();


MainWindow *themw;

void reload() {
	themw->dumpDataToFm();

}

static void useage() {
	fprintf(stderr,"useage: opledit [-d device] [-n] [file]\n");
	fprintf(stderr,"	-n          dont use OPL3 synth to play sounds\n");
	fprintf(stderr,"	-d <device> use <device> for incoming midi events\n");
	fprintf(stderr,"	            defaults to /dev/midi00\n");
	exit(1);
}

char *mididev="/dev/midi00";


int main (int argc,char *argv[]) {

	gtk_set_locale();
	gtk_init(&argc,&argv);

	bool want_synth=true;
	int c;
	while ((c = getopt(argc, argv, "d:nh")) != EOF) {
		switch(c) {
			case 'd':
				mididev = optarg; break;
			case 'n': want_synth = false; break;
			case 'h': 
			case '?':
			default:
					  useage(); 
		}

	}




	srand(time(NULL));

	MainWindow mw;
	themw = &mw;
	if(optind<argc)
		if(!mw.LoadFromFile(argv[optind])) {
			fprintf(stderr,"Error loading %s\n",argv[optind]);
			exit(2);
		}

	if(want_synth) {
		init_seq();
		g_idle_add(midi_idle,0);
	}
	
	mw.show();
	gtk_main();
	return 0;
}
